/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the MessageContactPhoto type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageContactPhoto{}

// MessageContactPhoto struct for MessageContactPhoto
type MessageContactPhoto struct {
	Data *string `json:"data,omitempty"`
	MimeType *string `json:"mime_type,omitempty"`
	Url *string `json:"url,omitempty"`
}

// NewMessageContactPhoto instantiates a new MessageContactPhoto object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageContactPhoto() *MessageContactPhoto {
	this := MessageContactPhoto{}
	return &this
}

// NewMessageContactPhotoWithDefaults instantiates a new MessageContactPhoto object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageContactPhotoWithDefaults() *MessageContactPhoto {
	this := MessageContactPhoto{}
	return &this
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *MessageContactPhoto) GetData() string {
	if o == nil || IsNil(o.Data) {
		var ret string
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactPhoto) GetDataOk() (*string, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *MessageContactPhoto) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given string and assigns it to the Data field.
func (o *MessageContactPhoto) SetData(v string) {
	o.Data = &v
}

// GetMimeType returns the MimeType field value if set, zero value otherwise.
func (o *MessageContactPhoto) GetMimeType() string {
	if o == nil || IsNil(o.MimeType) {
		var ret string
		return ret
	}
	return *o.MimeType
}

// GetMimeTypeOk returns a tuple with the MimeType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactPhoto) GetMimeTypeOk() (*string, bool) {
	if o == nil || IsNil(o.MimeType) {
		return nil, false
	}
	return o.MimeType, true
}

// HasMimeType returns a boolean if a field has been set.
func (o *MessageContactPhoto) HasMimeType() bool {
	if o != nil && !IsNil(o.MimeType) {
		return true
	}

	return false
}

// SetMimeType gets a reference to the given string and assigns it to the MimeType field.
func (o *MessageContactPhoto) SetMimeType(v string) {
	o.MimeType = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *MessageContactPhoto) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageContactPhoto) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *MessageContactPhoto) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *MessageContactPhoto) SetUrl(v string) {
	o.Url = &v
}

func (o MessageContactPhoto) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageContactPhoto) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.MimeType) {
		toSerialize["mime_type"] = o.MimeType
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	return toSerialize, nil
}

type NullableMessageContactPhoto struct {
	value *MessageContactPhoto
	isSet bool
}

func (v NullableMessageContactPhoto) Get() *MessageContactPhoto {
	return v.value
}

func (v *NullableMessageContactPhoto) Set(val *MessageContactPhoto) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageContactPhoto) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageContactPhoto) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageContactPhoto(val *MessageContactPhoto) *NullableMessageContactPhoto {
	return &NullableMessageContactPhoto{value: val, isSet: true}
}

func (v NullableMessageContactPhoto) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageContactPhoto) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


